-- Daily Global Check
-- by Jadya
-- EU-Well of Eternity

-- [[ Blizzard Interface Options Panels ]]--

local addonTitle, addonTable = ...
local L = addonTable.L

local addontitle = "|TInterface\\icons\\INV_Sigil_Freya:16 |t|cff00AAFFDaily Global Check|r"

function addonTable:GenerateOptionsPanel()

 local function OnOptionChanged(opt)
  if opt == "show_mapicons" then
   addonTable.forcemapupdate()
  end
 end

 local mainpanel = CreateFrame("Frame", "DGCOptionsPanel", UIParent)
 mainpanel.name = "Daily Global Check"
 InterfaceOptions_AddCategory(mainpanel)
 mainpanel:Hide()
 
 DailyGlobalCheck.OptionsPanel = CreateFrame("Frame", "DGCOptionsPanel", UIParent)
 local of = DailyGlobalCheck.OptionsPanel

-- main panel
 of:Hide()
 of.name = L["opt_main"]
 of.parent = "Daily Global Check"
 InterfaceOptions_AddCategory(of)
-- title
 of.title = of:CreateFontString()
 of.title:SetFont("Fonts\\FRIZQ__.ttf", 18, "")
 of.title:SetText(addontitle)
 of.title:SetPoint("TOP", of, "TOP", 0, -10)
 
 local chkcounter = 1
 
 local function CreateCheckbox(opt, text)
  local f = CreateFrame("CheckButton", "DGC_OptCheckbox"..chkcounter, of, "OptionsCheckButtonTemplate")
  table.insert(of.checkboxes, f)
   _G[f:GetName().."Text"]:SetText(text)
   f:SetPoint("TOPLEFT", of, "TOPLEFT", 10, -20 * chkcounter)
   f:SetScript("OnClick", function()
    if opt == "minimap_icon" then
      DailyGlobalCheck_Options["minimap_icon"].hide = not f:GetChecked()
 	 addonTable.ldbicon:Refresh("DailyGlobalCheck_broker", DailyGlobalCheck_broker, DailyGlobalCheck_Options["minimap_icon"])
    else
     DailyGlobalCheck_Options[opt] = f:GetChecked()
	 OnOptionChanged(opt)
	 addonTable.refresh()
    end
  end)
 
  if opt == "minimap_icon" then
   f:SetChecked(not DailyGlobalCheck_Options["minimap_icon"].hide)
  else
   f:SetChecked(DailyGlobalCheck_Options[opt])
  end
  chkcounter = chkcounter + 1
 end
 
 of.checkboxes = {}
 CreateCheckbox("minimap_icon",L["opt_minimap"],tx_minimap)
 chkcounter = chkcounter + 1
 CreateCheckbox("show_questtype", L["opt_questtype"],tx_questtype)
 CreateCheckbox("show_prefix", L["opt_prefix"],tx_pref)
 CreateCheckbox("show_zone", L["opt_zonename"],tx_zone)
 CreateCheckbox("show_suffix", L["opt_suffix"],tx_suff)
 CreateCheckbox("show_coordinates", L["opt_coords"],tx_coords)
 CreateCheckbox("show_mapicons", L["opt_map"],tx_worldmap)
 CreateCheckbox("show_questlogbtn", L["opt_showquestbtn"],dgcico)
 
 DailyGlobalCheck.OptCharPanel = CreateFrame("Frame", "DGCOptCharactersPanel", UIParent)
 of = DailyGlobalCheck.OptCharPanel

-- main panel
 of:Hide()
 of.name = L["opt_characters"]
 of.parent = "Daily Global Check"
 InterfaceOptions_AddCategory(of)

 of.lblblacklist = of:CreateFontString(nil, "OVERLAY", "GameTooltipText")
 of.lblblacklist:SetPoint("TOPLEFT", of, "TOPLEFT", 10, -10)
 of.lblblacklist:SetText(L["opt_blacklist_remove"])
 
 of.ddblacklist = CreateFrame("Button", "DropDownMenuTest", of, "UIDropDownMenuTemplate")
 of.ddblacklist:SetPoint("TOPLEFT", of.lblblacklist, "BOTTOMLEFT", 0, -10)
 
 local function ddonclick(self)
   local t = DailyGlobalCheck_Options["chars_blacklist"]
   local pid = self.value
   
   local i = -1
   foreach(t, function(k,v) if v == pid then i = k return end end)
   
   if i > -1 then
    table.remove(t, i)
	self.disabled = true
	print(string.format(L["chars_restored"], pid))
   end
 end
 
 local function initialize(self, level)
   local info = UIDropDownMenu_CreateInfo()
   for k,v in pairs(DailyGlobalCheck_Options["chars_blacklist"]) do
      info = UIDropDownMenu_CreateInfo()
      info.text = v
      info.value = v
      info.func = ddonclick
      UIDropDownMenu_AddButton(info, level)
   end
 end
 
 of:SetScript("OnShow", function()
    UIDropDownMenu_Initialize(of.ddblacklist, initialize)
   end)
end